uniform mat4 uMVPMatrix; 	//ܱ任
uniform mat4 uMMatrix; 		//任
uniform vec3 uLightLocation;	//Դλ
uniform vec3 uCamera;		//λ
attribute vec3 aPosition;  	//λ
attribute vec3 aNormal;   	//
varying vec3 vPosition;		//ڴݸƬԪɫĶλ
varying vec4 vSpecular;		//ڴݸƬԪɫľǿ
void pointLight(				//λռķ
  in vec3 normal,			//
  inout vec4 specular,		//淴  
  in vec3 lightLocation,		//Դλ
  in vec4 lightSpecular		//ǿ
){ 
  vec3 normalTarget=aPosition+normal; 	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(aPosition,1)).xyz;
  newNormal=normalize(newNormal);  	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*vec4(aPosition,1)).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*vec4(aPosition,1)).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ  
  float shininess=50.0;				//ֲڶȣԽСԽ⻬    
  float nDotViewHalfVector=dot(newNormal,halfVector);			//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    //յľǿ
}
void main()  {                        		
   gl_Position = uMVPMatrix * vec4(aPosition,1); //ܱ任˴λƴ˶λ      
   vec4 specularTemp=vec4(0.0,0.0,0.0,0.0);   
   pointLight(normalize(aNormal), specularTemp, uLightLocation, vec4(0.7,0.7,0.7,1.0));//㾵  
   vSpecular=specularTemp;	//վǿȴƬԪɫ   
   vPosition = aPosition; 		//λôƬԪɫ
} 
